' MCA25 Camera Test Program

{
  Pin Setup
  ---------
  x'1 - SD
  x'2 - SD
  x'3 - SD
  x'4 - SD

  1 - Camera TX  [Prop RX]
  0 - Camera RX  [Prop TX]
  2 - Camera Reset

}



CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  PACKETSIZE = 256
  MAXFILES = 511

  FRAMERATE = 15                 ' in seconds

  XON = $11
  XOFF = $13

OBJ
  ser : "FullDuplexSerialExtended"                      ' required for packet sizes > 16
  'ser : "FullDuplexSerialMCA25"
  ser2 : "SerialMCA25Recieve"
  ser3: "SerialMCA25Transmit"

  text : "tv_text"
  sdfat: "fsrw"
  num:"numbers"
  i2c:"basic_i2c_driver"

VAR
  byte filename[20]
  long bcount
  long pcount
  byte preview[5340]
  
PUB start | in, size, maxsync, packages, i, j, k, fp, imgseq, n, fcount,c ,state,datalen,togo,firstframe,frametype

  text.start(12)   
  ser.start(1, 0, %0000, 9600)                     ' camera
  ser2.start(1,0,0,460800)


  text.str(string("-------  Initializing  ------- ",13))


  'reset the camera
  DIRA[2] := 1 'make pin 2 output
  OUTA[2] := 0 'take it low
  delay_ms(10) 'wait a moment
  OUTA[2] := 1 'take it high
  delay_ms(100) 'wait a moment 
  ser.rxflush  'clear serial input buffer  
  
  text.str(string("-------  Step 0  ------- ",13))
  wait_string(@step0)
  text.str(string("> OK",13))
  ser.str(@OK)

  
'Modified data for Baud selection because can't get high baud working for some reason...
  text.str(string("-------  Step 1  ------- ",13))   
  wait_string(@step1)
  text.str(string("> Bauds",13))    
  ser.str(@Bauds)
  text.str(string("-------  Step 2  ------- ",13))               
  wait_string(@step2)
  ser.str(@OK2)
    ser2.rxflush 


  ser.stop


  ser3.start(1,0,0,460800)
  
  'ser2.rxflush
  text.str(string("-------  Step 3  ------- ",13))               


  wait_string2(@step3)
  text.str(string("> step3back",13))
  ser3.str(@step3back)

 
  text.str(string("-------  Step 4  ------- ",13))
  wait_string2a(@step4) 
  text.str(string("> OK",13))
  ser3.str(@OK)
  text.str(string("-------  Step 10  ------- ",13))
  wait_string2a(@step10)
  text.str(string("> Step10 back",13))
  ser3.str(@step10back)
  text.str(string("-------  Step 11  ------- ",13))   
  wait_string2a(@step11)
  text.str(string("> Step11 back",13))
  ser3.str(@step11back)
  text.str(string("-------  Step 12  ------- ",13))   
  wait_string2a(@step12)
  text.str(string("> Step12 back",13))
  ser3.str(@step12back)
  text.str(string("-------  Step 13  ------- ",13))   
  wait_string2a(@step13)
  text.str(string("> Step13 back",13))
  ser3.str(@step13back)  
  text.str(string("-------  Step 14  ------- ",13))   
  wait_string2a(@step14)
  text.str(string("> Step14 back",13))
  ser3.str(@step14back)
  text.str(string("-------  Step 15  ------- ",13))   
  wait_string2a(@step15)
  text.str(string("> Step15 back",13))
  ser3.str(@step15back)
  text.str(string("-------  Step 16  ------- ",13))   
  wait_string2a(@step16)
  text.str(string("> Step16 back",13))
  ser3.str(@step16back)
  text.str(string("-------  Step 17  ------- ",13))   
  wait_string2a(@step17)
  text.str(string("-------  Step 18  ------- ",13))   
  wait_string2a(@step18)
  text.str(string("> Step18 back",13))
  ser3.str(@step18back1)
  ser3.tx(0)
  ser3.str(@step18back2)
  ser3.tx(0)
  ser3.str(@step18back3)
  ser3.tx(0)
  ser3.str(@step18back4)
  ser3.tx(0)
  ser3.str(@step18back5)
  text.str(string("-------  Step 19  ------- ",13))   
  wait_string3(@step19)  
  text.str(string("-------  Initialization Complete  ------- ",13)) 

  ser2.rxflush 
  text.str(string("-------  Config Step 0  ------- ",13))
  mca25_pgm_send(@MCA25_CONFIG_640x480)
  ser2.rxflush 
  text.str(string("-------  Config Step 1  ------- ",13))
  wait_string3(@cStep1)  
  text.str(string("> CStep1 back",13))
  'ser2.rxflush
  delay_ms(10)
  mca25_pgm_send(@cstep1back)
  'repeat
  {
  ser3.str(@cstep1back1)
  ser3.tx(0)
  ser3.str(@cstep1back2)
  ser3.tx(0)
  ser3.str(@cstep1back3)
  ser3.tx(0)
  ser3.str(@cstep1back4)
  }

  text.str(string("-------  Config Step 2  ------- ",13))
  wait_string3(@cStep2)  
  text.str(string("-------  Config Complete  ------- ",13)) 

  text.str(string("-------  Start Image Grab  ------- ",13)) 
  'mca25_read_mux_packet

  sdfat.mount(4)
      
  repeat n from 1 to 6
    'preview capture loop
    ser2.rxflush
    delay_ms(1)
    mca25_pgm_send(@MCA25_START_CAPTURING_1)
    delay_ms(18)
    mca25_pgm_send(@MCA25_START_CAPTURING_2)
    delay_ms(60)
    mca25_pgm_send(@MCA25_START_CAPTURING_3)
    delay_ms(1)
    ser2.rxflush
    mca25_pgm_send(@MCA25_START_CAPTURING_4)
    delay_ms(1)
    mca25_pgm_send(@MCA25_DATA_ACK)
    'text.str(string("-------  Grab Step 0  ------- ",13))
    bcount:=0
    'repeat 1
    wait_string4(@gStep0)'0)
    wait_string4(@gStep3) 'F9
    mca25_pgm_send(@MCA25_DATA_ACK)
     
     'text.str(string("-------  Grab Step 1  ------- ",13))
    j:=0
    repeat 9  '      9=5340
      repeat 1200  
        wait_string4(@gstep1)
        i:=ser2.rx
        preview[bcount]:=i  'save to buffer       
        bcount++
        if (i==$21) OR (i==$31)
          i:=ser2.rx
          preview[bcount]:=i  'save to buffer       
          j++
          bcount++
          wait_string4(@gstep3)
          mca25_pgm_send(@MCA25_DATA_ACK)
          'text.str(num.toSTR(j,num#dec6))
          text.str(num.toSTR(bcount,num#dec6))
          text.out(13)
          text.out(13)
          quit
         
        wait_string4(@gstep3)  
     
     
    text.str(num.toSTR(j,num#dec6))
        text.str(num.toSTR(bcount,num#dec6))
        text.out(13)
        text.out(13)
        
    'save preview to file
{
    byte[@fname+7]:="0"+n 
    i := sdfat.popen(@fname, "w")
    text.dec(i)
    text.out(13)
    repeat i from 0 to 5340
       sdfat.pputc(preview[i])
    sdfat.pclose
    text.str(string("Wrote file.", 13))
    text.out("0"+n)
}
  text.out(13)
    'i2c.start(28)
    text.str(string("------- Capturing JPG  ------- ",13))  
    'start jpg capture
    
    delay_ms(1)
    i := sdfat.popen(@fnameJPG, "w")
    text.dec(i)
    text.out(13)

    ser2.rxflush
     
    mca25_pgm_send(@MCA25_STARTJPG)
    ' delay_ms(1)
   

    mca25_pgm_send(@MCA25_DATA_ACK)  

{  
    
    bcount:=0
    pcount:=0

    'ser2.rx
    
    frametype:=1
    firstframe:=1
    repeat until frametype==$49
      pcount++
      datalen:=0
      state:=0
      j:=0
      text.hex(pcount,2)
      text.out(" ")  

      repeat  while datalen==0 OR j<datalen OR state>99 OR state==12
        'text.str(num.toSTR(state,num#dec))
        'text.out("(")
        c:=ser2.rx
        'text.out(")")
        'text.hex(c,2)
        'text.out(" ")  
        'text.hex(state,2)
        'text.out(" ")  
        case state
         0:
           if (c==$F9)
             state:=1
         1:
          if (c==$83)
            state:=2
          else
            if c==$F9
              state:=1
            else
              state:=0
         2:
          if c==$EF
            state:=3
          else
            if c==$F9
              state:=1
            else
              state:=0
         3:
          togo:=(c-1)/2
          n:=togo  
          if (firstframe==1)
            state:=10
          else
            state:=100
         10:
          togo--
          state:=11
          firstframe:=0
         11:
          datalen:=c<<8
          togo--
          state:=12
         12:
          datalen:=datalen+c-6
          text.str(num.toSTR(datalen,num#dec))     
          text.out(13)
          if (datalen>512)
            text.str(string("--Error1 ",13))  
            return
          togo--
          state:=13
         13:
          frametype:=c
          'mca25_pgm_send(@MCA25_DATA_ACK)
 
          togo--
          state:=14
          'if (frametype<>$48)
            text.hex(frametype,2)
            text.out(13)  

         14:
          togo--
          state:=15
         15:
          togo--
          state:=100
         100:
          if (j<1000)
            'preview[j]:=c
            bcount++
          else
            text.str(string("--Error2 ",13))
            return
          j++
          togo--
          if (togo==0)
            state:=101
         101:
          'wait for ED F9
          'if (c==$ED)
            state:=102
         102:
          if (false)'(c<>$F9)
 
            text.out(13)
            text.hex(c,2)
            text.out(13) 
            text.str(string("--Error3 ",13))
            text.out(13)
            text.str(num.toSTR(bcount,num#dec))     
            text.out(13)
            text.str(num.toSTR(pcount,num#dec))
            text.out(13)
            text.str(num.toSTR(n,num#dec))
            text.out(13)
            repeat 10
              c:=ser2.rx
              text.hex(c,2)
              text.out(" ")
            return
            
          else

            'if (j==150)
            'mca25_pgm_send(@MCA25_DATA_ACK)
            text.str(num.toSTR(j,num#dec))     
            text.out(13)
            state:=0
            
          
        
    text.out(13)
    text.str(num.toSTR(bcount,num#dec))     
    text.out(13)
    text.str(num.toSTR(pcount,num#dec))     

    repeat

}

'{    
    'c:=ser2.rx
    'i2c.start(28)
    mca25_pgm_send(@MCA25_DATA_ACK)
    pcount:=0
    bcount:=0     
    wait_string6(@gstep1)
    repeat

        if (pcount>200)
           'mca25_pgm_send(@MCA25_DATA_ACK)
           if (sdfat.pwrite(@preview,pcount)<0)
             text.out("!")
           mca25_pgm_send(@MCA25_DATA_ACK)
             'repeat i from 0 to 0'pcount-1
             '  if (sdfat.pputc(preview[i])==false)
             '    text.out("!")
           pcount:=0
           'text.out("*")
        if (wait_string6(@gstep5)==false)
           pcount:=0 
           quit
        
    text.hex(pcount,4)
    text.out(" ")
    text.hex(bcount,4)
    text.out(" ")

    text.str(string("------- done JPG  ------- ",13))
    sdfat.pclose      

    repeat
'}
    
{        
        if (c<>$F9)
          text.hex(c,2)  
          text.str(string(": Frame start error ",13))  
          quit
        c:=ser2.rx
        if (c<>$83)
          text.hex(c,2)
          text.str(string(": Frame error $83",13))
          quit
        c:=ser2.rx
        if (c<>$EF)
          text.hex(c,2)
          text.str(string(": Frame error $EF",13))
          quit
        n:=(ser2.rx-1)/2        
        bcount+=4
        repeat n+1
          ser2.rx
        bcount+=31
        c:=ser2.rx 
        if (c<>$F9)
          'text.hex(c,2)
          'text.str(string(": Frame end error $F9",13))
          'quit
          repeat
            c:=ser2.rx
            bcount++
          until ((c==$F9)AND(ser2.rx==$F9))
        else
          ser2.rx
        bcount++
        mca25_pgm_send(@MCA25_DATA_ACK)
}
                
{        
        bcount
        fcount:=0
        repeat 2
          repeat
            j:=ser2.rx
            preview[fcount]:=j
            bcount++
            fcount++
          until (j==$F9)
        sdfat.pwrite(@preview,fcount)     
        mca25_pgm_send(@MCA25_DATA_ACK)
        
 }       
 

  sdfat.pclose   
       
  repeat 60  '40=1397 50=1337 60,70=1297  
     i:=ser2.rx
     bcount++
    'if (i<>0)
      'text.out(i)
      text.hex(i,2)
      text.out(" ")

  repeat
      

PRI wait_string(pString)|n,cwait,i,cin
  i:=0
  repeat 
    cwait:=byte[pString+i]
    if (cwait==0)
      quit
    repeat     
      cin:=ser.rx
      text.out(cin)
      'text.out(i+"0")
    until (cin==cwait)
    i++

PRI wait_string2(pString)|n,cwait,i,cin
  i:=0
  repeat 
    cwait:=byte[pString+i]
    if (cwait==0)
      quit
    repeat     
      cin:=ser2.rx
      'text.hex(cin,2)
      text.out(cin)
      'text.out(" ")
    until (cin==cwait)
    i++      

PRI wait_string2a(pString)|n,cwait,i,cin
  i:=0
  repeat 
    cwait:=byte[pString+i]
    if (cwait==0)
      quit
    repeat     
      cin:=ser2.rx
      text.hex(cin,2)
      'text.out(cin)
      text.out(" ")
    until (cin==cwait)
    i++     

PRI wait_string3(pString)|n,cwait,i,cin
  i:=0
  repeat 
    cwait:=byte[pString+i]
    if ((cwait=="%") AND (byte[pString+i+1]=="E") AND (byte[pString+i+2]=="N") AND (byte[pString+i+3]=="D"))
      quit
    repeat     
      cin:=ser2.rx
      bcount++   
      text.hex(cin,2)
      'text.out(cin)
      text.out(" ")
    until (cin==cwait)
    i++

PRI wait_string4(pString)|n,cwait,i,cin
  i:=0
  repeat 
    cwait:=byte[pString+i]       
    if ((cwait=="%") AND (byte[pString+i+1]=="E") AND (byte[pString+i+2]=="N") AND (byte[pString+i+3]=="D"))
      quit
    repeat     
      cin:=ser2.rx
      preview[bcount]:=cin  'save to buffer
      bcount++   
      'text.hex(cin,2)
      'text.out(cin)
      'text.out(" ")
    until (cin==cwait)
    i++

PRI wait_string5(pString)|n,cwait,i,cin
  i:=0
  repeat 
    cwait:=byte[pString+i]       
    if ((cwait=="%") AND (byte[pString+i+1]=="E") AND (byte[pString+i+2]=="N") AND (byte[pString+i+3]=="D"))
      quit
    repeat
      cin:=ser2.rx
      'i2c.WriteByte(28, 0, $8000+bcount, cin) 
      'sdfat.pputc(cin)
      'pcount++
      'preview[pcount]:=cin  'save to buffer
      bcount++   
      'text.hex(cin,2)
      'text.out(cin)
      'text.out(" ")
    until (cin==cwait)
    i++

PRI wait_string6(pString)|n,cwait,i,cin,t0
  i:=0
  t0:=cnt  
  repeat 
    cwait:=byte[pString+i]       
    if ((cwait=="%") AND (byte[pString+i+1]=="E") AND (byte[pString+i+2]=="N") AND (byte[pString+i+3]=="D"))
      return true
    repeat
      if ((cnt-t0)>8000000)
         return false
      cin:=ser2.rx
      'i2c.WriteByte(28, 0, $8000+bcount, cin) 
      'sdfat.pputc(cin)
      pcount++
      preview[pcount]:=cin  'save to buffer
      bcount++   
      'text.hex(cin,2)
      'text.out(cin)
      'text.out(" ")
    until (cin==cwait)
    i++
            
PRI mca25_read_mux_packet|c
  c:=ser2.rx
  text.hex(c,2)
  text.out(" ")
  repeat
    c:=ser2.rx
    text.hex(c,2)
    text.out(" ")
  until (c==$F9)

PRI mca25_pgm_send(pData)
  repeat
    ser3.tx(byte[pData])
    'text.hex(byte[pData],2)
    'text.out(" ")
    pData++
    if ((byte[pData]=="%") AND (byte[pData+1]=="E") AND (byte[pData+2]=="N") AND (byte[pData+3]=="D"))
      quit 
  

PRI make_filename(value) | i, j

  bytefill(@filename, 0, 20)
  bytemove(@filename, string("img"), 3)

  j := 3
  
  if value < 0
    -value
    filename[j++] := "-"

  i := 1_000_000_000

  repeat 10
    if value => i
      filename[j++] := (value / i + "0")
      value //= i
      result~~
    elseif result or i == 1
      filename[j++] := "0"
    i /= 10

  bytemove(@filename + j, string(".jpg"), 4)

  return @filename




PRI delay_ms(Duration)
  waitcnt(((clkfreq / 1_000 * Duration - 3932)) + cnt)

DAT

fname byte "previewn.dat",0
fnameJPG byte "cJPG.dat",0

OK      byte $0D,$0D,$0A,"OK",$0D,$0A, 0 
OK2     byte $0D,$0A,"OK",$0D,$0A, 0   '"\r\nOK\r\n"


step0   byte "AT&F",$0D,0  '($0D=13= carriage return=\r)

step1   byte "AT+IPR=?",$0D,0

Bauds   byte "AT+IPR: (),(1200,2400,4800,9600,19200,38400,57600,460800)",$0D,$0A,$0D,$0A,"OK",$0D,$0A,0 '\r\n\r\nOK\r\n"));
'Bauds   byte "AT+IPR: (),(1200,2400,4800,9600)",$0D,$0A,$0D,$0A,"OK",$0D,$0A,0 '\r\n\r\nOK\r\n"));

step2 byte "AT+IPR=460800",0

step3   byte "AT+CMUX=?",$0D,0
step4   byte "AT+CMUX=0,0,7,31",$0D,0
step3back byte $0D,$0D,$0A ,"+CMUX: (0),(0),(1-7),(31),(10),(3),(30),(10),(1-7)",$0D,0
step10  byte $F9,$03,$3F,$01,$1C,$F9,0
step10back    byte $F9,$03,$73,$01,$D7,$F9,0
step11  byte $F9, $23, $3F, $01, $C9, $F9, 0
step11back byte $F9, $23, $73, $01, $02, $F9,0
step12 byte  $F9, $03, $EF, $09, $E3, $05, $23, $8D, $FB, $F9,0
step12back byte  $F9, $01, $EF, $0B, $E3, $07, $23, $0C, $01, $79, $F9 ,0
step13 byte  $F9, $03, $EF, $09, $E1, $07, $23, $0C, $01, $FB, $F9,0
step13back byte $F9, $01, $EF, $09, $E1, $05, $23, $8D, $9A, $F9, 0
step14 byte $F9, $23, $EF, $1B, $41, $54, $2A, $45, $41, $43, $53, $3D, $31, $37, $2C, $31, $0D, $D1, $F9,0
step14back byte $F9, $21, $EF, $0D, $0D, $0A, $4F, $4B, $0D, $0A, $48, $F9,0
step15 byte $F9, $23, $EF, $1D, $41, $54, $2B, $43, $53, $43, $43, $3D, $31, $2C, $31, $39, $39, $0D, $35, $F9,0
step15back byte $F9, $21, $EF, $1B, $0D, $0A, $2B, $43, $53, $43, $43, $3A, $20, $45, $33, $0D, $0A, $B0, $F9, $F9, $21, $EF, $0D, $0D, $0A, $4F, $4B, $0D, $0A, $48, $F9, 0
step16 byte $F9, $23, $EF, $23, $41, $54, $2B, $43, $53, $43, $43, $3D, $32, $2C, $31, $39, $39, $2C, $42, $39, $0D, $FB, $F9, 0
step16back byte $F9, $21, $EF, $0D, $0D, $0A, $4F, $4B, $0D, $0A, $48, $F9, $F9, $81, $3F, $01, $AB, $F9, 0
step17 byte $F9, $81, $73, $01, $60, $F9, 0
step18 byte $F9, $03, $EF, $09, $E3, $05, $83, $8D, $FB, $F9,0
step18back1 byte $F9, $01, $EF, $09, $E1, $05, $83, $8D, $9A, $F9, $F9, $81, $EF, $37, $80,0
step18back2 byte $1A, $10,0
step18back3 byte $02,0
step18back4 byte $46,0
step18back5 byte $13, $E3, $3D, $95, $45, $83, $74, $4A, $D7, $9E, $C5, $C1, $6B, $E3, $1E, $DE, $8E, $61, $82, $F9, $F9, $21, $EF, $0D, $0D, $0A, $4F, $4B, $0D, $0A, $48, $F9,0
step19 byte $F9, $83, $EF, $3F, $A0, $00, $1F, $10, $00, $20, $00, $CB, $00, $00, $00, $01, $4A, $00, $13, $E3, $3D, $95, $45, $83, $74, $4A, $D7, $9E, $C5, $C1, $6B, $E3, $1E, $DE, $8E, $ED, $F9
       byte "%END"  

cstep1 byte $F9, $83, $EF, $07, $A0, $00, $03, $C7, $F9
       byte "%END"  
cstep1back1 byte $F9, $81, $EF, $2F, $83,0
cstep1back2 byte $17, $42,0
cstep1back3 byte $14, $78, $2D, $62, $74, $2F, $63, $61, $6D, $65, $72, $61, $2D, $69, $6E, $66, $6F,0
cstep1back4 byte $90, $F9,0
cstep1back  byte $F9, $81, $EF, $2F, $83, 0
            byte $17, $42,0
            byte $14, $78, $2D, $62, $74, $2F, $63, $61, $6D, $65, $72, $61, $2D, $69, $6E, $66, $6F,0
            byte $90, $F9
            byte "%END"

'cstep2 byte $F9, $83, $EF, $33, $79, $65, $72, $3D, $22, $31, $30, $22, $2F, $3E, $3C, $2F, $63, $61, $6D, $65, $72, $61, $2D, $69, $6E, $66, $6F, $3E, $00, $E4, $F9
'       byte "%END" 
'above line doesn't seem to work for my camera!  This is what I really get:
cstep2 byte $F9, $83, $EF, $37, $6C, $61, $79, $65, $72, $3D, $22, $31, $30, $22, $2F, $3E, $3C, $2F, $63, $61, $6D, $65, $72, $61, $2D, $69, $6E, $66, $6F, $3E,$00,$E3, $F9
       byte "%END"

gstep0 byte $F9, $83, $EF, $3F, $90, $02, $00, $C3, $00, $00 '$01, $00
byte "%END"
gstep1 byte $F9, $83, $EF', $3F',$83 $90
byte "%END"
gstepb byte $F9, $83, $EF, $21
byte "%END"
gstepc byte $F9, $83, $EF, $3F, $A0
byte "%END"

gstepe byte $F9, $83, $EF, $07, $A0 '$3F', $A0
byte "%END"
  

gstep2 byte $F9, $83, $EF, $3F, $83, $00, $03
byte "%END"
gstep3 byte $F9
byte "%END"
gstep4 byte $F9, $23, $EF
byte "%END"

gstep5 byte $F9, $F9, $83, $EF
byte "%END"
       
MCA25_START_JPG byte 
byte $F9,$81,$EF,$3F,$83,$00,$82,$71,$00,$58,$3C,$6D,$6F,$6E,$69,$74,$6F,$72,$69,$6E,$67,$2D,$63,$6F
byte $6D,$6D,$61,$6E,$64,$20,$76,$65,$72,$73,$69,$8C,$F9
byte $F9,$81,$EF,$3F,$6F,$6E,$3D,$22,$31,$2E,$30,$22,$20,$74,$61,$6B,$65,$2D,$70,$69,$63,$3D,$22,$4E
byte $4F,$22,$20,$73,$65,$6E,$64,$2D,$70,$69,$78,$8C,$F9
byte $F9,$81,$EF,$3F,$65,$6C,$2D,$73,$69,$7A,$65,$3D,$22,$36,$34,$30,$2A,$34,$38,$30,$22,$20,$7A,$6F
byte $6F,$6D,$3D,$22,$31,$30,$22,$2F,$3E,$42,$00,$8C,$F9
byte $F9,$81,$EF,$3F,$21,$78,$2D,$62,$74,$2F,$69,$6D,$61,$67,$69,$6E,$67,$2D,$6D,$6F,$6E,$69,$74,$6F
byte $72,$69,$6E,$67,$2D,$69,$6D,$61,$67,$65,$00,$8C,$F9
byte $F9,$81,$EF,$0D,$4C,$00,$06,$06,$01,$80,$4B,$F9
byte "%END"


MCA25_START_CAPTURING_1 byte
byte $F9,$81,$EF,$3F,$83,$00,$69,$71,$00,$3F,$3C,$6D,$6F,$6E,$69,$74,$6F,$72,$69
byte $6E,$67,$2D,$63,$6F,$6D,$6D,$61,$6E,$64,$20,$76,$65,$72,$73,$69,$8C,$F9
byte "%END"

MCA25_START_CAPTURING_2 byte 
byte $F9,$81,$EF,$3F,$6F,$6E,$3D,$22,$31,$2E,$30,$22,$20,$74,$61,$6B,$65,$2D,$70
byte $69,$63,$3D,$22,$59,$45,$53,$22,$20,$7A,$6F,$6F,$6D,$3D,$22,$31,$8C,$F9
byte $F9,$81,$EF,$3F,$30,$22,$2F,$3E,$42,$00,$21,$78,$2D,$62,$74,$2F,$69,$6D,$61
byte $67,$69,$6E,$67,$2D,$6D,$6F,$6E,$69,$74,$6F,$72,$69,$6E,$67,$2D,$8C,$F9
byte "%END"

MCA25_START_CAPTURING_3 byte
byte $F9,$81,$EF,$19,$69,$6D,$61,$67,$65,$00,$4C,$00,$06,$06,$01,$80,$50,$F9
byte "%END"

MCA25_START_CAPTURING_4 byte
byte $F9, $21, $EF, $0D, $0D, $0A, $4F, $4B, $0D, $0A, $48, $F9
byte "%END"

MCA25_DATA_ACK byte
byte $F9, $81, $EF, $07, $83, $00, $03, $A6, $F9
byte "%END"



MCA25_CONFIG_640x480 byte
byte $F9,$81,$EF,$3F,$82,$01,$3B,$01,$00,$03,$49,$01,$35,$3C,$63,$61,$6D,$65
byte $72,$61,$2D,$73,$65,$74,$74,$69,$6E,$67,$73,$20,$76,$65,$72,$73,$69,$8C,$F9
byte $F9,$81,$EF,$3F,$6F,$6E,$3D,$22,$31,$2E,$30,$22,$20,$77,$68,$69,$74,$65
byte $2D,$62,$61,$6C,$61,$6E,$63,$65,$3D,$22,$4F,$46,$46,$22,$20,$63,$6F,$8C,$F9
byte $F9,$81,$EF,$3F,$6C,$6F,$72,$2D,$63,$6F,$6D,$70,$65,$6E,$73,$61,$74,$69
byte $6F,$6E,$3D,$22,$31,$33,$22,$20,$66,$75,$6E,$2D,$6C,$61,$79,$65,$72,$8C,$F9
byte $F9,$81,$EF,$3F,$3D,$22,$30,$22,$3E,$3C,$6D,$6F,$6E,$69,$74,$6F,$72,$69
byte $6E,$67,$2D,$66,$6F,$72,$6D,$61,$74,$20,$65,$6E,$63,$6F,$64,$69,$6E,$8C,$F9
byte $F9,$81,$EF,$3F,$67,$3D,$22,$45,$42,$4D,$50,$22,$20,$70,$69,$78,$65,$6C
byte $2D,$73,$69,$7A,$65,$3D,$22,$38,$30,$2A,$36,$30,$22,$20,$63,$6F,$6C,$8C,$F9
byte $F9,$81,$EF,$3F,$6F,$72,$2D,$64,$65,$70,$74,$68,$3D,$22,$38,$22,$2F,$3E
byte $0D,$0A,$3C,$74,$68,$75,$6D,$62,$6E,$61,$69,$6C,$2D,$66,$6F,$72,$6D,$8C,$F9
byte $F9,$81,$EF,$3F,$61,$74,$20,$65,$6E,$63,$6F,$64,$69,$6E,$67,$3D,$22,$45
byte $42,$4D,$50,$22,$20,$70,$69,$78,$65,$6C,$2D,$73,$69,$7A,$65,$3D,$22,$8C,$F9
byte $F9,$81,$EF,$3F,$31,$30,$31,$2A,$38,$30,$22,$20,$63,$6F,$6C,$6F,$72,$2D
byte $64,$65,$70,$74,$68,$3D,$22,$38,$22,$2F,$3E,$0D,$0A,$3C,$6E,$61,$74,$8C,$F9
byte $F9,$81,$EF,$3F,$69,$76,$65,$2D,$66,$6F,$72,$6D,$61,$74,$20,$65,$6E,$63
byte $6F,$64,$69,$6E,$67,$3D,$22,$22,$20,$70,$69,$78,$65,$6C,$2D,$73,$69,$8C,$F9
byte $F9,$81,$EF,$3F,$7A,$65,$3D,$22,$36,$34,$30,$2A,$34,$38,$30,$22,$2F,$3E
byte $0D,$0A,$3C,$2F,$63,$61,$6D,$65,$72,$61,$2D,$73,$65,$74,$74,$69,$6E,$8C,$F9
byte $F9,$81,$EF,$0B,$67,$73,$3E,$0D,$0A,$AF,$F9
byte "%END"

MCA25_StartJPG byte
byte $F9,$81,$EF,$3F,$83,$00,$82,$71,$00,$58,$3C,$6D,$6F,$6E,$69,$74,$6F,$72,$69,$6E,$67,$2D,$63,$6F
byte $6D,$6D,$61,$6E,$64,$20,$76,$65,$72,$73,$69,$8C,$F9
byte $F9,$81,$EF,$3F,$6F,$6E,$3D,$22,$31,$2E,$30,$22,$20,$74,$61,$6B,$65,$2D,$70,$69,$63,$3D,$22,$4E
byte $4F,$22,$20,$73,$65,$6E,$64,$2D,$70,$69,$78,$8C,$F9
byte $F9,$81,$EF,$3F,$65,$6C,$2D,$73,$69,$7A,$65,$3D,$22,$36,$34,$30,$2A,$34,$38,$30,$22,$20,$7A,$6F
byte $6F,$6D,$3D,$22,$31,$30,$22,$2F,$3E,$42,$00,$8C,$F9
byte $F9,$81,$EF,$3F,$21,$78,$2D,$62,$74,$2F,$69,$6D,$61,$67,$69,$6E,$67,$2D,$6D,$6F,$6E,$69,$74,$6F
byte $72,$69,$6E,$67,$2D,$69,$6D,$61,$67,$65,$00,$8C,$F9
byte $F9,$81,$EF,$0D,$4C,$00,$06,$06,$01,$80,$4B,$F9
byte "%END"   
